coxfit.spls <-
function(y, d, x, i.idx=NULL, tuning=c(1,30,1), cutoff=10){

    n<-dim(x)[1]; p<-dim(x)[2]
    if (is.vector(x)==TRUE) {n<-length(x); p<-1}

    starting<-min(which(d==1))     
      
    ## Elimination of the data ignored 
    y.all<-y
    y<-y[starting:n]; x<-x[starting:n,]; d<-d[starting:n]

    n<-length(y)
    
    ## traingular matrix Mi
    Mi<-round(lower.tri(matrix(1, n, n),diag=TRUE))[,d==1]
    
    ## initial of coef
    b<-rep(0,p)
    
    ## Tuning parameter : lambda(sigma), w, number of PLS components
    sig<-1/tuning[1]; w<-tuning[2]; K<-tuning[3]
        
if (is.null(i.idx)==TRUE){
                  
    econv<-999;niter<-0
    
    while(econv>1e-02 && niter<20){
        niter<-niter+1  
        eta<-x%*%b
        cla0<-1/(c(t(Mi)%*%exp(eta)))
        clam0<-c(Mi%*%cla0)   
    
        mu<-c(clam0*exp(eta))                  
        z<-eta + (d-mu)/mu
        
        X<-x 
        Ps<-Rs<-matrix(0,p,K); Qs<-rep(0,K);Ts<-matrix(0,n,K)
       
 
    for (k in 1:K){
           
            W1<-sum(z^2*mu)
            r<-c(t(X)%*%(z*mu)) ## Initial estimator
            #r<-rep(0.1,p)
            r<-r/sqrt(sum(r^2))
            
            ## Sparse step for loading
            econv.r<-1; niter.r<-0    
            while(econv.r>1e-04 && niter.r<10){  
            niter.r<-niter.r+1
                r.old<-r       
                uhat <- 0.25*( sqrt(8*w*r^2/sig + (2-w)^2) + 2-w) + 1e-08
                W2 <- 1/uhat/sig
                r<- (t(X)%*%(z*mu))/(W1+W2)
                r<-r/sqrt(sum(r^2))
               econv.r<-max(abs(r-r.old))
                
            #print(econv.r)
            }
            r<-round(r,digit=cutoff)
            r<-r/sqrt(sum(r^2)) ## p*1 loading vector
            Temp<-c(X%*%r) ## n*1 vector
            sumTemp<- sum(Temp^2*mu)         
            q<-sum(z*Temp*mu)/sumTemp
            P<-c(t(X)%*%(Temp*mu))/sumTemp
            
            ## Residual
            z<-z-c(q*Temp)
            X<-X-(Temp%*%t(P))
        Ps[,k]<-P 
        Rs[,k]<-r 
        Qs[k]<-q 
        Ts[,k]<-Temp 
        
        
        }            
         b.old<-b   
         PsRs<- t(Ps)%*%Rs
         b<-c(Rs%*%solve(PsRs, Qs))
        
         if ( niter>5){

            SS<-23;logPLv<-rep(0,SS)
            for (ss in 1:SS){
                b.mid<-(SS-ss)/(SS-1)*(b.old-(b-b.old))+(ss-1)/(SS-1)*(b.old+(b-b.old))
             #logPLv[ss]<-logPL(y,d,x,b.mid) 
             logPLv[ss]<-logPL.simple(y,d,x,b.mid,Mi)
            }
            ss<-which.max(logPLv); b<-(SS-ss)/(SS-1)*(b.old-(b-b.old))+(ss-1)/(SS-1)*(b.old+(b-b.old))
         }    

    
    econv<-max(abs(b-b.old))
   }        
}


if (is.null(i.idx)==FALSE){
   
    x1<-x[,-i.idx]; x2<-x[,i.idx]
    p1<-dim(x1)[2]; 
    if (length(i.idx)>1) {p2<-dim(x2)[2]; }
    if (length(i.idx)==1) {p2<-1;x2<-matrix(x2,n,1) }
    
    p<-p1+p2
    
    ## Initial estimate of beta
    b<-rep(0,p); b1<-rep(0,p1); b2<-rep(0,p2)
        
    eta<-eta1<-eta2<-rep(0,n)
                
    econv<-999;niter<-0
    
    while(econv>1e-02 && niter<20){
        niter<-niter+1

        eta<-x%*%b
        cla0<-1/(c(t(Mi)%*%exp(eta)))
        clam0<-c(Mi%*%cla0)   
    
        mu<-c(clam0*exp(eta))                  
        z<-eta1 + (d-mu)/mu
        
        X<-x1 
        Ps<-Rs<-matrix(0,p1,K); Qs<-rep(0,K);Ts<-matrix(0,n,K)
       
 
    for (k in 1:K){
           
            W1<-sum(z^2*mu)
            r<-c(t(X)%*%(z*mu)) ## Initial estimator
            #r<-rep(0.1,p)
            r<-r/sqrt(sum(r^2))
            
            ## Sparse step for loading
            econv.r<-1; niter.r<-0    
            while(econv.r>1e-04 && niter.r<10){  
            niter.r<-niter.r+1
                r.old<-r       
                uhat <- 0.25*( sqrt(8*w*r^2/sig + (2-w)^2) + 2-w) + 1e-08
                W2 <- 1/uhat/sig
                r<- (t(X)%*%(z*mu))/(W1+W2)
                r<-r/sqrt(sum(r^2))
               econv.r<-max(abs(r-r.old))
                
            #print(econv.r)
            }
            
            r<-round(r,digit=cutoff)
            r<-r/sqrt(sum(r^2)) ## p*1 loading vector
            Temp<-c(X%*%r) ## n*1 vector
            sumTemp<-sum(Temp^2*mu)          
            q<-sum(z*Temp*mu)/sumTemp
            P<-c(t(X)%*%(Temp*mu))/sumTemp
            
            ## Residual
            z<-z-c(q*Temp)
            X<-X-(Temp%*%t(P))
        Ps[,k]<-P 
        Rs[,k]<-r 
        Qs[k]<-q 
        Ts[,k]<-Temp 
        
        
        }            
   
        b.old<-b    
        PsRs<-  t(Ps)%*%Rs
        b1<-c(Rs%*%solve(PsRs, Qs))
        eta1<-Ts%*%Qs
        ## estimation of b2
        
        ## adjusted dependent variable 
        z2<-eta2 + (d-mu)/mu
        
        ## new estimate of b2
        x2vx2<-   t(x2)%*%(x2*mu)
        x2vz2<-   c(t(x2)%*%(z2*mu))
        b2<-solve(x2vx2,x2vz2 )
        eta2<-x2%*%b2
        b[-i.idx]<-b1; b[i.idx]<-b2
        
        
        
        if ( niter>5){

            SS<-23;logPLv<-rep(0,SS)
            for (ss in 1:SS){
                b.mid<-(SS-ss)/(SS-1)*(b.old-(b-b.old))+(ss-1)/(SS-1)*(b.old+(b-b.old))
                logPLv[ss]<-logPL.simple(y,d,x,b.mid,Mi)
            }
            ss<-which.max(logPLv); b<-(SS-ss)/(SS-1)*(b.old-(b-b.old))+(ss-1)/(SS-1)*(b.old+(b-b.old))
         }    

 
    econv<-max(abs(b-b.old))
    #print(c(niter, econv))   
    }        
}

clam0<-c(rep(0,starting-1),clam0)
times<-y.all
#cat(paste("Iterations : ",niter," Convergence : ",econv,sep=" ","\n")) 
return(list(coef=b,i.idx=i.idx, Ps=Ps,Rs=Rs,Qs=Qs,mu=mu, clam0=c(clam0), times=times))
}
