coxfit.sreg <-
function(y,d,x, i.idx=NULL, tuning=c(1,30),cutoff=10){
    
    # i.idx : The column index of the covariate should be included

    n<-dim(x)[1]; p<-dim(x)[2]
    if (is.vector(x)==TRUE) {n<-length(x); p<-1}

    starting<-min(which(d==1))     
      
    ## Elimination of the data ignored 
    y.all<-y
    y<-y[starting:n]; x<-x[starting:n,]; d<-d[starting:n]

    n<-length(y)
    
    ## traingular matrix Mi
    Mi<-round(lower.tri(matrix(1, n, n),diag=TRUE))[,d==1]
    
    ## initial of coef
    b<-rep(0,p)
            
    ## Tuning parameter sigma and w
    sig<-1/tuning[1]; w<-tuning[2]
                
    econv<-1;niter<-0

    while(econv>1e-02 && niter<20){ 
        niter<-niter+1  
        eta<-c(x%*%b) 
        expeta<-exp(eta)
        cla0<-1/(c(t(Mi)%*%expeta)) ## lambda(tt_j) : Increment of the cumulative basline hazard at time tt_j for j=1,...,D
        clam0<-c(Mi%*%cla0)         ## Lambda(y_i)  : Cumulative basline hazard at time y_i for i=1,...,n
         
        uhat <- 0.25*( sqrt(8*w*b^2/sig + (2-w)^2) + 2-w) + 1e-08
        if (niter==1){ uhat<-rep(1,p) }
        uhat[i.idx]<-Inf
        WW <- diag(1/uhat/sig)
        
        mu<-c(clam0*expeta)
        
        z<-eta + (d-mu)/mu
        
        b.old<-b
        
        xvx<-t(x)%*%(x*mu) + WW
        xvz<- c(t(x)%*%(z*mu))
                
        b<- solve( xvx, xvz)
        
        if ( niter>5){

           SS<-23;logPLv<-rep(0,SS)
            for (ss in 1:SS){
                b.mid<-(SS-ss)/(SS-1)*(b.old-(b-b.old))+(ss-1)/(SS-1)*(b.old+(b-b.old))
               logPLv[ss]<-logPL.simple(y,d,x,b.mid,Mi)
            }
            ss<-which.max(logPLv); b<-(SS-ss)/(SS-1)*(b.old-(b-b.old))+(ss-1)/(SS-1)*(b.old+(b-b.old))
         }    

        econv<-max(abs(b-b.old))
        #print(c(niter, econv))      
    }
#cat(paste("Iterations : ",niter," Convergence : ",econv,sep=" ","\n"))

clam0<-c(rep(0,starting-1),clam0)
times<-y.all
b<-round(b,digit=cutoff)


return(list(coef=b, i.idx=i.idx, clam0=c(clam0), times=times))
}
