cv.coxfit <-
function(y,d,x, i.idx=NULL, method="spls", idx=NULL, fold = 5, tau.vec=c(1), w.vec=c(30), K.vec=c(1),print=FALSE ){
    
    n<-dim(x)[1]; p<-dim(x)[2]
   
    set.seed(12345) 
    foldi <- split(sample(1:n), rep(1:fold, length = n))
    cvmat <-array(0, c(length(tau.vec), length(w.vec), length(K.vec)))
        
    for (i in 1:length(tau.vec)) {  
        
        
        for (j in 1:length(w.vec)){    
            for (k in 1:length(K.vec)){        
            
            if (print==TRUE){cat(paste("tau =", tau.vec[i], "w =", w.vec[j], "K =", K.vec[k], "\n")) }
            
            tau<-tau.vec[i]; w<-w.vec[j]; K<-K.vec[k]
                       
            for (ff in 1:fold) {
                omit <- sort(foldi[[ff]])
                
                y.train<-y[-omit]; d.train<-d[-omit];x.train<-x[-omit,]

                if (method=="sreg") {object <- coxfit.sreg(y.train,d.train,x.train, i.idx, tuning=c(tau,w), cutoff=4)}
                
                if (method=="spls") {object <- coxfit.spls(y.train,d.train,x.train, i.idx, tuning=c(tau,w,K), cutoff=4)}
                
                ## partial log-likelihood 
                y.new<-y[omit]; d.new<-d[omit]; x.new<-as.matrix(x[omit,])

                b<-c(object$coef); clam0<-c(object$clam0)
                
                lik<-logPL(y.new,d.new,x.new,b)
                
                cvmat[i,j,k]<-cvmat[i,j,k]+lik
                
                }
                
            
        }}}
        
    opt.idx<- which(cvmat==max(cvmat), arr.ind=T)

    tau.opt <- tau.vec[opt.idx[1]]
    w.opt <- w.vec[opt.idx[2]]
    K.opt    <- K.vec[opt.idx[3]]
    
    cat(paste("\n Optimal parameters for partial likelihood criterion : tau = ", tau.opt, ", ", sep = ""))
    cat(paste("w = ", w.opt, "\n", sep = ""))
    cat(paste("K = ", K.opt, "\n", sep = ""))
    
    opt<-c(tau.opt,w.opt, K.opt)


    lasso.idx<-which(cvmat==max(cvmat[,1,]),arr.ind=T)
    tau.opt <- tau.vec[lasso.idx[1]]
    w.opt <- w.vec[lasso.idx[2]]
    K.opt    <- K.vec[lasso.idx[3]]           

    L1.opt<-c(tau.opt,w.opt, K.opt)

    cv <- list(cvmat = cvmat, opt = opt, L1.opt=L1.opt)
    invisible(cv)
}
